-- Fredzaza --

Regime = {};

function Regime.prerequisitesPresent(specializations)
      return true;
end;
function Regime.initSpecialization()
end
function Regime.registerOverwrittenFunctions(vehicleType)
end
function Regime.registerFunctions(vehicleType)	
end
function Regime.registerEvents(vehicleType)
end
function Regime:registerActionEventsPlayer()
end
function Regime:registerActionEventsMenu()
end

function Regime:onRegisterActionEvents(isSelected, isOnActiveVehicle)
	if isOnActiveVehicle then
		if self.Regime == nil then 
			self.Regime = {}
		else	
			self:clearActionEventsTable( self.Regime )
		end 
		for _,actionName in pairs({"Regime_Motor_ECR355E"}) do
			local _, eventName = self:addActionEvent(self.Regime, InputAction[actionName], self, Regime.actionCallback, true, true, false, true, nil);
	
			if isSelected then
				g_inputBinding.events[eventName].displayPriority = 1
			elseif  isOnActiveVehicle then
				g_inputBinding.events[eventName].displayPriority = 3
			end
		end
	end
end

function Regime.registerEventListeners(vehicleType)
	SpecializationUtil.registerEventListener(vehicleType, "onLoad", Regime)
	SpecializationUtil.registerEventListener(vehicleType, "onDelete", Regime)
    SpecializationUtil.registerEventListener(vehicleType, "onReadStream", Regime)
    SpecializationUtil.registerEventListener(vehicleType, "onWriteStream", Regime)
    --SpecializationUtil.registerEventListener(vehicleType, "onReadUpdateStream", Regime)
    --SpecializationUtil.registerEventListener(vehicleType, "onWriteUpdateStream", Regime)
	SpecializationUtil.registerEventListener(vehicleType, "onUpdate", Regime)
	SpecializationUtil.registerEventListener(vehicleType, "onDraw", Regime)
	SpecializationUtil.registerEventListener(vehicleType, "onRegisterActionEvents", Regime)

end

function Regime:onLoad(vehicle)	
	local spec = self.spec_regime

	self.demarrage = Regime.demarrage
	self.hautregime = Regime.hautregime
	self.regimeforce = Regime.regimeforce
	self.forceregimehaut = Regime.forceregimehaut
	self.forceregimebas = Regime.forceregimebas
	
	self.Regimehaut= false
	self.Regimeenhaut = false
	self.Regimeenbas = true
	self.Regimeforcage = false
	self.fonctionA = false
	self.fonctionB = false
	self.forceplayed = false
	self.forcebaisseplayed = true

	self.samples = {}
    if self.isClient then
        self.samples.ralenti = g_soundManager:loadSampleFromXML(self.xmlFile, "vehicle.sounds", "ralentiSound", self.baseDirectory, self.components, 0, AudioGroup.VEHICLE, self.i3dMappings, self)
		self.samples.inicio = g_soundManager:loadSampleFromXML(self.xmlFile, "vehicle.sounds", "Inicio_Regime", self.baseDirectory, self.components, 1, AudioGroup.VEHICLE, self.i3dMappings, self)
		self.samples.haut = g_soundManager:loadSampleFromXML(self.xmlFile, "vehicle.sounds", "hautSound", self.baseDirectory, self.components, 0, AudioGroup.VEHICLE, self.i3dMappings, self)
		self.samples.baisse = g_soundManager:loadSampleFromXML(self.xmlFile, "vehicle.sounds", "baisseSound", self.baseDirectory, self.components, 1, AudioGroup.VEHICLE, self.i3dMappings, self)
		self.samples.hydro = g_soundManager:loadSampleFromXML(self.xmlFile, "vehicle.sounds", "hydroSound", self.baseDirectory, self.components, 0, AudioGroup.VEHICLE, self.i3dMappings, self)
		self.samples.demarage = g_soundManager:loadSampleFromXML(self.xmlFile, "vehicle.sounds", "demarageSound", self.baseDirectory, self.components, 1, AudioGroup.VEHICLE, self.i3dMappings, self)  
		self.samples.fhausse = g_soundManager:loadSampleFromXML(self.xmlFile, "vehicle.sounds", "fhausseSound", self.baseDirectory, self.components, 1, AudioGroup.VEHICLE, self.i3dMappings, self)
		self.samples.fbaisse = g_soundManager:loadSampleFromXML(self.xmlFile, "vehicle.sounds", "fbaisseSound", self.baseDirectory, self.components, 1, AudioGroup.VEHICLE, self.i3dMappings, self)
		self.samples.fhaut = g_soundManager:loadSampleFromXML(self.xmlFile, "vehicle.sounds", "fhautSound", self.baseDirectory, self.components, 0, AudioGroup.VEHICLE, self.i3dMappings, self)
	end
	--self.baldevisualexcavadora = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.baldevisualexcavadora#index"));
	self.attachervisual = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.attachervisual#index"));
end;

function Regime:onDelete() 
		g_soundManager:stopSample(self.samples.inicio)
		g_soundManager:stopSample(self.samples.haut)
		g_soundManager:stopSample(self.samples.baisse)
		g_soundManager:stopSample(self.samples.ralenti)
		g_soundManager:stopSample(self.samples.demarage)
		g_soundManager:stopSample(self.samples.fhausse)
		g_soundManager:stopSample(self.samples.fbaisse)
		g_soundManager:stopSample(self.samples.fhaut)
end;

function Regime:onReadStream(streamId, connection)
	local Regimehaut = streamReadBool(streamId)
    self:hautregime(Regimehaut, true)
	local Regimeforcage = streamReadBool(streamId)
    self:regimeforce(Regimeforcage, true)
end;
  
function Regime:onWriteStream(streamId, connection)
    local spec = self.spec_regime
	streamWriteBool(streamId, spec.Regimehaut)
	streamWriteBool(streamId, spec.Regimeforcage)
end;

function Regime:mouseEvent(posX, posY, isDown, isUp, button)
end;

function Regime:keyEvent(unicode, sym, modifier, isDown)    
end;

function Regime:onUpdate(dt, vehicle)
	local spec = self.spec_regime
	local spece = self.spec_motorized
	local speci = self.spec_cylindered
	
	for i=1, table.getn(speci.movingTools) do
		local tool1 = speci.movingTools[1]
		local tool2 = speci.movingTools[2]
		local tool3 = speci.movingTools[3]
		local tool4 = speci.movingTools[4]
		local tool5 = speci.movingTools[5]
		local tool6 = speci.movingTools[6]
		local accInput = spece:getAxisForward()
		if tool1.lastRotSpeed > 0.0001 or tool1.lastRotSpeed < -0.0001 or tool2.lastRotSpeed > 0.0001 or tool2.lastRotSpeed < -0.0001 or tool3.lastRotSpeed > 0.0001 or tool3.lastRotSpeed < -0.0001 or tool4.lastRotSpeed > 0.0001 or tool4.lastRotSpeed < -0.0001 or tool5.lastRotSpeed > 0.0001 or tool5.lastRotSpeed < -0.0001 or tool6.lastRotSpeed > 0.0001 or tool6.lastRotSpeed < -0.0001 or spece:getCruiseControlState() == Drivable.CRUISECONTROL_STATE_ACTIVE or accInput ~= 0 then
			self.Regimeforcage = true
		else
			self.Regimeforcage = false
		end;
	end;
	if self.Regimeforcage then		
		self:regimeforce(true)
	else
		self:regimeforce(false)
	end;	
	if self.Regimehaut then
		if self.Regimeforcage then		
			if not g_soundManager:getIsSamplePlaying(self.samples.fhausse, 1.5*dt) and not g_soundManager:getIsSamplePlaying(self.samples.fbaisse, 1.5*dt) and not self.forceplayed then 
				self.forceplayed = true
				self.forcebaisseplayed = false
			end;
		else	
			if not g_soundManager:getIsSamplePlaying(self.samples.fbaisse, 1.5*dt) and not g_soundManager:getIsSamplePlaying(self.samples.fhausse, 1.5*dt) and not self.forcebaisseplayed then 
				self.forceplayed = false
				self.forcebaisseplayed = true
			end;
		end;	
	end;		
					
	if spece.isMotorStarted then	
		if not self.Regimedemarage then
			self:demarrage()
		end;		
		if self.Regimehaut then
			if not g_soundManager:getIsSamplePlaying(self.samples.inicio, 1.5*dt) then
				if self.Regimeforcage then
					if not g_soundManager:getIsSamplePlaying(self.samples.fhausse, 1.5*dt) and not g_soundManager:getIsSamplePlaying(self.samples.fbaisse, 1.5*dt) and not g_soundManager:getIsSamplePlaying(self.samples.inicio, 1.5*dt) and not g_soundManager:getIsSamplePlaying(self.samples.baisse, 1.5*dt) and not self.fonctionA then
						g_soundManager:playSample(self.samples.fhausse)
						g_soundManager:playSample(self.samples.fhaut, 0, self.samples.fhausse)
						g_soundManager:playSample(self.samples.haut)
						self.fonctionA = true
						self.fonctionB = false
					end;
				else
					if not g_soundManager:getIsSamplePlaying(self.samples.fbaisse, 1.5*dt) and not g_soundManager:getIsSamplePlaying(self.samples.fhausse, 1.5*dt) and not g_soundManager:getIsSamplePlaying(self.samples.inicio, 1.5*dt) and not g_soundManager:getIsSamplePlaying(self.samples.baisse, 1.5*dt) and not self.fonctionB then
						g_soundManager:playSample(self.samples.fbaisse)
						g_soundManager:playSample(self.samples.haut, 0, self.samples.fbaisse)
						g_soundManager:stopSample(self.samples.fhaut)
						self.fonctionA = false
						self.fonctionB = true
					end;	
				end;
			end;
		else	
			g_soundManager:stopSample(self.samples.inicio)
			g_soundManager:stopSample(self.samples.haut)
			g_soundManager:stopSample(self.samples.fhausse)
			g_soundManager:stopSample(self.samples.fbaisse)
			g_soundManager:stopSample(self.samples.fhaut)
		end;
	else
		g_soundManager:stopSample(self.samples.inicio)
		g_soundManager:stopSample(self.samples.haut)
		g_soundManager:stopSample(self.samples.baisse)
		g_soundManager:stopSample(self.samples.ralenti)
		g_soundManager:stopSample(self.samples.demarage)
		g_soundManager:stopSample(self.samples.fhausse)
		g_soundManager:stopSample(self.samples.fbaisse)
		g_soundManager:stopSample(self.samples.fhaut)

		
		self.Regimehaut = false						
		self.Regimeenhaut = false
		self.Regimeenbas = true
		self.Regimedemarage = false
	end;
end;

function Regime:onUpdateTick() 
end;	
function Regime:onLeaveVehicle()
end;       
function Regime:onDraw()  
end;

function Regime:actionCallback(actionName, keyStatus, arg4, arg5, arg6)
	if keyStatus > 0 then
		if actionName == 'Regime_Motor_ECR355E' then
			if self.Regimehaut then
				self:hautregime(false)
			else 
				self:hautregime(true)
			end
		end
	end
end

function Regime:demarrage()
	local spec = self.spec_regime
	local spece = self.spec_motorized
	self.Regimedemarage = true
	if self.isClient then
		g_soundManager:playSample(self.samples.demarage)
		g_soundManager:playSample(self.samples.ralenti, 0, self.samples.demarage)
		--g_soundManager:stopSamples(spece.motorSamples)
	end;
end;

function Regime:hautregime(Regimehaut, noEventSend)
	RegimehautEvent.sendEvent(self, Regimehaut, noEventSend)
	local spece = self.spec_motorized
	self.Regimehaut = Regimehaut
	if self.Regimedemarage then
		if self.Regimehaut and not self.Regimeenhaut then
			self.Regimeenhaut = true
			self.Regimeenbas = false
			g_soundManager:playSample(self.samples.inicio, 0, spece.samples.motorStart)
			g_soundManager:playSample(self.samples.haut, 0, self.samples.inicio)
			--g_soundManager:stopSamples(spece.motorSamples)
			g_soundManager:stopSample(self.samples.baisse)
			g_soundManager:stopSample(self.samples.ralenti)
			g_soundManager.stopSample(self.samples.fhaut);
			g_soundManager.stopSample(self.samples.fhausse);
			g_soundManager.stopSample(self.samples.fbaisse);
		end;	
		if not self.Regimehaut and not self.Regimeenbas then
			self.Regimeenbas = true				
			self.Regimeenhaut = false
			g_soundManager:playSample(self.samples.baisse)
			g_soundManager:playSample(self.samples.ralenti, 0, self.samples.baisse)
			--g_soundManager:stopSamples(spece.motorSamples)
			g_soundManager:stopSample(self.samples.inicio)
			g_soundManager:stopSample(self.samples.haut)
			g_soundManager.stopSample(self.samples.fhaut);
			g_soundManager.stopSample(self.samples.fhausse);
			g_soundManager.stopSample(self.samples.fbaisse);
		end;
	end;		
end;

function Regime:regimeforce(Regimeforcage, noEventSend)
	RegimeforcagetEvent.sendEvent(self, Regimeforcage, noEventSend)
	self.Regimeforcage = Regimeforcage		
end;

--- Event ---

RegimehautEvent = {};
RegimehautEvent_mt = Class(RegimehautEvent, Event);
InitEventClass(RegimehautEvent, "RegimehautEvent");

function RegimehautEvent:emptyNew()
    local self = Event:new(RegimehautEvent_mt);
    return self;
end;
function RegimehautEvent:new(object, Regimehaut)
	local self = RegimehautEvent:emptyNew()
	self.object = object;
	self.Regimehaut = Regimehaut;
	return self;
end;
function RegimehautEvent:readStream(streamId, connection)
	self.object = NetworkUtil.readNodeObject(streamId);
	self.Regimehaut = streamReadBool(streamId);
	self:run(connection);
end;
function RegimehautEvent:writeStream(streamId, connection)
	NetworkUtil.writeNodeObject(streamId, self.object);
	streamWriteBool(streamId, self.Regimehaut);
end;
function RegimehautEvent:run(connection)
	if not connection:getIsServer() then
		g_server:broadcastEvent(self, false, connection, self.object);
	end;
	if self.object ~= nil then
		self.object:hautregime(self.Regimehaut, true);
	end;
end;
function RegimehautEvent.sendEvent(vehicle, Regimehaut, noEventSend)
	if Regimehaut ~= vehicle.Regimehaut then
		if noEventSend == nil or noEventSend == false then
			if g_server ~= nil then
				g_server:broadcastEvent(RegimehautEvent:new(vehicle, Regimehaut), nil, nil, vehicle);
			else
				g_client:getServerConnection():sendEvent(RegimehautEvent:new(vehicle, Regimehaut));
			end;
		end;
	end;
end;

RegimeforcagetEvent = {};
RegimeforcagetEvent_mt = Class(RegimeforcagetEvent, Event);
InitEventClass(RegimeforcagetEvent, "RegimeforcagetEvent");

function RegimeforcagetEvent:emptyNew()
    local self = Event:new(RegimeforcagetEvent_mt);
    return self;
end;
function RegimeforcagetEvent:new(object, Regimeforcage)
	local self = RegimeforcagetEvent:emptyNew()
	self.object = object;
	self.Regimeforcage = Regimeforcage;
	return self;
end;
function RegimeforcagetEvent:readStream(streamId, connection)
	self.object = NetworkUtil.readNodeObject(streamId);
	self.Regimeforcage = streamReadBool(streamId);
	self:run(connection);
end;
function RegimeforcagetEvent:writeStream(streamId, connection)
	NetworkUtil.writeNodeObject(streamId, self.object);
	streamWriteBool(streamId, self.Regimeforcage);
end;
function RegimeforcagetEvent:run(connection)
	if not connection:getIsServer() then
		g_server:broadcastEvent(self, false, connection, self.object);
	end;
	if self.object ~= nil then
		self.object:regimeforce(self.Regimeforcage, true);
	end;
end;
function RegimeforcagetEvent.sendEvent(vehicle, Regimeforcage, noEventSend)
	if Regimeforcage ~= vehicle.Regimeforcage then
		if noEventSend == nil or noEventSend == false then
			if g_server ~= nil then
				g_server:broadcastEvent(RegimeforcagetEvent:new(vehicle, Regimeforcage), nil, nil, vehicle);
			else
				g_client:getServerConnection():sendEvent(RegimeforcagetEvent:new(vehicle, Regimeforcage));
			end;
		end;
	end;
end;